Structure Window Commands

Please select a command group from the menu bar of the structure window:

  • File
  • View
  • Select
  • Style
  • Window
  • CDD


Structure Window : File

Structure Window : File Commands

  • Open
  • Network Load
  • Save
  • Save As
  • Export PNG
  • Realign Structures
  • Preferences
  • Set Fonts
  • Exit

Open

Open a structure file from the local disk. This can be an ASCII or binary ASN1 file, which must contain data of either the Ncbi-mime-asn1 or Cdd types (which will always be true of files downloaded from NCBI structure-based servers). If a there is already a structure being viewed, you will be prompted to save any changes before opening the new file.

Network Load

This is a shortcut to loading particular structures. Enter either a 4-letter PDB code or an MMDB integer ID. Cn3D will connect to NCBI's MMDB database via the internet and download that structure directly, which you can then manipulate as usual or save to a local file if desired.

Save

Save the current data to a file on the local disk, using the same filename and data type as was initially loaded. Cn3D will assume all editing changes are to be kept.

Save As

Similar to Save except a dialog will appear in which you can choose a diectory and file name and specify either ASCII or binary type files.

Export PNG

Save the image currently displayed in the structure window to a PNG-format file. First, you will be prompted for a file name and path. Then you will see a dialog that allows you to control the image export parameters, with these fields:

  • File name: the current path to the file to be saved.
  • Width and Height: the size (in pixels) of the image. The dimensions can be smaller or larger than the current window; this is useful for creating small thumbnails, or high resolution images for hardcopy output.
  • Maintain Aspect: keep the same relative width/height as the current structure window. If unchecked, the view may not correspond exactly to what you see in the structure window.
  • Interlaced: whether to create an interlaced PNG file. Interlacing is mainly for web images; it is unavailable for larger images.

Once you have set all the appropriate parameters, hit OK. You will see a small progress meter as the file is created; you'll have to wait until export is finished before continuing.

Realign Structures

Re-compute the structure alignment(s) between multiple structures. Each structure will be realigned with the first structure of the alignment, according to a rigid body fit using only the alpha carbon coordinates of residues in aligned blocks. The RMSD between the coordinate sets for each pair of structures will be printed in the message log. If there are aligned columns selected in the sequence window, then a dialog will appear asking whether to use only the selected residues for structure alignment.

Preferences

Brings up the Preferences dialog. These are program configuration options that persist from one session to another. There are three panels in this dialog:

Quality: controls the faceting resolution of various 3D objects. OpenGL (the 3D graphics system used by Cn3D) draws "smooth" objects like spheres out of many small triangles. These options control just how small the triangles are: more triangles means a smoother, more rounded appearance, but which takes longer to draw - making Cn3D respond more slowly. The Presets buttons are a convenience to adjust an overall rendering quality, from Low which draws quickly but looks jagged, to High which may draw slowly but will look much nicer, especially in a large window or an exported image file. You can also choose between Perspective and Orthographic projections.

Cache: controls the Biostruc caching system. This is an advanced option and by default will not affect most users. Certain NCBI data files may not actually contain structure information, but only alignments and annotations, etc.; Cn3D has to use a network connection to download structures from NCBI's MMDB server. These structures can be cached in order to avoid repeatedly transferring the same structures over a slow network connection. This panel allows you to set the location of the cache, and limit the amount of disk space it will use.

Advanced:

  • The CDD Annotations checkbox controls whether CDD annotation information is read-only (the default) or editable. Un-check this option if you want to edit the annotation information stored in a local CDD file.
  • Max structures: a limit of how many structures to load from a file with a multi-structured alignment.
  • Footprint residues: In certain BLAST operations (like self-hits), the alignment is restricted to the currently aligned footprint, for avoiding ambiguity with repeated domains. The "excess" specified here allows the alignment to extend that many residues beyond the existing footprint.
  • Eye separation: controls the stereo view, how great the depth of the perceived stereo appears.
  • Proximal: whether to use proximal (cross-eyed) or distal (uncrossed) stereo.
  • Browser Launch: (UNIX ONLY) tells Cn3D how to launch a web browser on your system. The default is netscape, for which the launch command is:

    ( netscape -raise -remote 'openURL(<URL>)' || netscape '<URL>' ) >/dev/null 2>&1 &

    This brings up the document in an existing netscape window; if you want to use a new window for each document, use the command:

    ( netscape -noraise -remote 'openURL(<URL>,new-window)' || netscape '<URL>' ) >/dev/null 2>&1 &

    These command strings should be all on one line. You can customize the command to launch any browser you wish. Each occurrence of the string <URL> will be replaced by the actual URL of the web page Cn3D is launching.

Set Fonts

Sets the fonts used in the structure and sequence windows. Like the Preferences above, these settings are persistent across multiple Cn3D sessions.

Exit

Exit the program. You will be prompted to write out any unsaved changes.


Structure Window : View

Structure Window : View Commands

  • Zoom in
  • Zoom out
  • Restore
  • Reset
  • Next frame
  • Previous frame
  • First frame
  • Last frame
  • All frames
  • Animation
  • Stereo

Zoom in

Zoom the camera in towards the structure - makes the structure bigger.

Zoom out

Zoom the camera away from the structure - makes the structure smaller.

Restore

Restore the camera angle stored the last time the structure was saved to a file. Same as Reset when no view information has been saved.

Reset

Reset the camera angle so that the entire structure is visible inside the window.

Next frame

Switch to the next frame, or the first frame if all frames are currently visible.

A "frame" means different things depending on what type of data is being viewed. If the structure is a single MMDB entry, but is for example an NMR solution where the original PDB entry contains multiple models, then each frame will contain one model. If it's a single structure, but the PDB entry has disordered residues, then each frame will contain one ensemble of disordered coordinates. If you're viewing a multiple-structure file (like a CDD or a VAST alignment), then each frame contains a separate PDB structure.

Previous frame

Switch to the previous frame. (See the description of frames above.)

First frame

Switch to the first frame. (See the description of frames above.)

Last frame

Switch to the last frame. (See the description of frames above.)

All frames

Show all frames simultaneously. (See the description of frames above.)

Animation

There are two different types of animation available: frames and spinning. Play frames will flip through the frames without moving the structure, whereas Spin will continuously rotate the current structure. Stop will discontinue either type of animation. Set delay allows you to specify the time - in milliseconds - spent on each frame (and so applies to frame animation only); a smaller value will make the animation go faster.

Stereo

Show the structure in side-by-side stereo. Controls for specifics of the stereo view are in the advanced tab of the Preferences panel.


Structure Window : Select

Structure Window : Select Commands

  • Pick structures
  • Show everything
  • Show aligned chains
  • Show aligned domains
  • Show aligned residues
  • Unaligned residues
  • Show selected domains
  • Show selected residues
  • Select by distance
  • Toggle chain
  • Select molecule

Pick structures

This dialog allows you to manually select which parts of which structures are visible. You will see a hierarchical list of all structures (for example, "1BML"), biopolymer chains in each structure (such as "1BML_C"), and domains in each chain (like "1BML_C d2"). You can turn each part on and off by clicking any line to select or deselect that part of the structure - a highlighted line means that part is visible. (On the Macintosh, you'll need to hold down the Meta key when clicking.) Because the assembly is hierarchical, if you turn of a chain, all domains in that chain will also be turned off. Similarly, if you turn on a domain, the chain that contains that domain will also be turned on.

Show everything

Makes all parts of all structures visible.

Show aligned chains

Shows only chains that contain residues that are in aligned blocks of the current alignment.

Show aligned domains

Shows only domains that contain residues that are in aligned blocks of the current alignment. This is convenient to trim down the display when several multi-domain and/or multi-chain PDB structures are represented in the alignment.

Show aligned residues

Shows only residues that are in aligned blocks of the current alignment. This is useful for examining the conserved structural core of an alignment.

Unaligned residues

Shows unaligned residues. There are two choices: show all unaligned residues, or show unaligned residues only in aligned domains. The latter is particularly useful for examining unconserved loop regions of the structural core.

Show selected domains

Shows only domains that contain selected residues.

Show selected residues

Shows only selected (highlighted) residues.

Select by distance

These functions allow you to highlight residues based on distance between atoms. To use this feature, first select any number of residues (or solvent or heterogen molecules) in either the structure or sequence window. Then do Select by Distance and enter a distance cutoff. This will add highlights to all biopolymer residues (or all molecules, including heterogens and solvents) that contain any atom within this distance from any atom in the initially selected set of residues, based on center-to-center separation. The options checkboxes allow you to choose what types of residues will be selected, and the other option lets you select only residues that are on different molecules from the initially selected residues (for focussing on intermolecular contacts).

Toggle chain

Brings up a dialog containing all chains of all molecules in the strucure. Selecting one or more chains will cause highlights on every residue of these chains to be toggled on/off.

Select molecule

Select a molecule by either the single-character PDB chain code, or the MMDB molecule integer ID. For individual structures only.


Structure Window : Style

Structure Window : Style Commands

  • Edit global style
    • Rendering styles
    • Coloring styles
  • Favorites
  • Rendering shortcuts
  • Coloring shortcuts
  • Annotate

Edit global style

Edit the global drawing style that applies to all structures. (To change the style of specific residues, see the Annotate item below.) This brings up the style editor panel. You will see the changes take effect immediately if the Apply after each change option is on; otherwise, changes will only occur when you click Apply or Done. The settings chosen here will be saved and restored automatically when you write your data out to a file. There are three tabbed panes in the style editor:

  • Settings tab: these items control rendering and coloring of the various structural elements. The columns in this panel are:
    • Group: which atoms or objects are controlled by each row.
    • Show: whether these items should be displayed, and for backbones, what type of backbone is drawn. Trace is alpha carbon or phosphate only; Partial shows all backbone atoms that make a linear chain.
    • Rendering: what shapes are used to draw these elements. See the descriptions of rendering styles below.
    • Color scheme: how these items are colored. See the descriptions of coloring styles below.
    • User color: press these buttons to select any color to use when Color scheme is set to User selection. On PC and UNIX, the background color of these buttons will be the color selected.
  • Labels tab: controls if and how residues are labeled.
    • Spacing: labels are drawn every N residues.
    • Type: one or three letter residue names are used.
    • Numbering: Sequential means residues are numbered in order starting from one; From PDB will use residue numbers from the original PDB file (which may be ordered arbitrarily).
    • Contrast: if selected, white labels are used if the background is a dark color, and black labels otherwise.
    • Termini: label the ends of the chains. For example, the N terminal residue of chain B will be labeled "N (B)".
    • Metal ions: whether to put the element symbol in the center of transparently-drawn metal ions.
  • Details tab: controls sizes of the various rendered objects. These numbers are in units of Angstroms, except for Space fill size which is a scale factor applied to the van der Waals radius of the element. For example, you can change the relative radii of atoms and bonds in a Ball and Stick model by adjusting the Ball radius and Stick radius items..

Rendering Styles

Both the style editor and the rendering shortcuts offer a variety of drawing styles. Here are descriptions of the available choices:

  • Wire worm: a curved thin line that is drawn through only the alpha carbons (or phosphates) of the backbone.
  • Tube worm: like wire worm, except a thick tube is drawn instead.
  • Wire: bonds between all atoms are drawn as straight thin lines.
  • Tube: bonds between all atoms are drawn as thick tubes.
  • Ball and stick: bonds are drawn as thick tubes, and atoms are represented by spheres.
  • Space fill (sometimes called CPK): atoms are drawn with larger spheres proportional to their van der Waals radii. No bonds are drawn.
  • With/without arrows: this is a special style that applies only to the objects that represent protein helices and strands, and controls whether or not arrowheads are used to indicate the N-to-C direction of the protein backbone.

Coloring Styles

Both the style editor and the coloring shortcuts offer a variety of color schemes. Coloring schemes typically control how atoms are colored; bonds are colored according to the colors of the atoms at each end. Here are descriptions of the available choices:

  • Element: colors by atomic element.
  • Object: each structure object - one MMDB/PDB entry - is assigned a different color.
  • Molecule: each molecule - one chain or heterogen or solvent - is assigned a different color.
  • Domain: each domain in a chain is assigned a different color.
  • Secondary structure: for protein chains, distinguishes helix, strand, and coil with different colors.
  • Temperature: uses a traditional temperature color cycle (blue - green - yellow - red - white) to indicate relative temperature factors for each atom, where blue is lowest and white highest temperature.
  • Rainbow: uses a ROYGBIV color cycle along each chain from N to C (or 5' to 3').
  • Charge: for proteins, draws positively charged residues in blue, negative in red, and neutral in gray.
  • Hydrophobicity: for proteins, uses a standard hydrophobicity scale to draw the most hydrophobic residues in red, to the least hydrophobic (most hydrophilic) in blue.
  • User selection: a solid color of the user's choice.
  • Sequence conservation: these schemes are all used to color sequence alignments in different ways based on sequence conservation.
    • Aligned: aligned residues are all red.
    • Identity: columns of identical residues are red, others blue.
    • Variety: columns with the lowest number of different amino acids represented are colored red, and highest variety columns are blue.
    • Weighted variety: similar to variety, but scaled by a standard BLOSUM62 substitution score so that columns of most strongly conserved residues are more red.
    • Information content: scales color according to the information content of each column, where a higher score is more red.
    • Fit: colors each residue according to how well it "fits" in the column it is in (based on residue-to-PSSM score). A residue colored red has a high substitution score given the other residues in that column; a blue color indicates a low score.
    • Block fit: similar to fit except residues are colored by blocks and ranked by the sum of residue-to-PSSM scores. The highest scoring blocks in the entire alignment are red, the lowest blue.
    • Normalized block fit: similar to block fit except scores are normalized within each column of aligned block; the highest scoring row in a given block column is red, the lowest blue.
    • Block row fit: Similar to normalized block fit excpet scores are normalized across each sequence row; the highest scoring block of a given sequence will be red, the lowest blue.

Favorites

The Favorites submenu allows you to define your own rendering and coloring styles, which you can save for future sessions. To use this feature, simply define any (global) style using the above style editor, then select Add/Replace and type in a name. A new menu item of that name will appear at the bottom of the Favorites submenu (or will replace an existing item of the same name), and when you select that item, this style will be used as the global style and applied to the current structures. You can use the Remove item to remove a style from your list. Your style definitions are saved in a file automatically; you can change the location of this file using Change File. This also allows you to keep different sets of favorite styles or even share these styles with others; when you do Change File, the styles in the current Favorites menu are replaced with the those in the file you select.

Rendering shortcuts

These are shortcuts to predefined rendering styles. They will change how structures are shaped, but colors will are unaffected. The shortcuts have the same meanings as the various rendering styles, but are applied to the entire structure rather than to specific groups. Toggle sidechains will turn side chains on or off in the current style.

Coloring shortcuts

These are shortcuts to predefined coloring styles. They will change how structures are colored, but shapes will be unaffected. The shortcuts have the same meanings as the various coloring styles, but are applied to the entire structure rather than to specific groups.

Annotate

This panel allows you to annotate a structure by defining different styles - rendering, coloring, and labeling - to specific sets of residues. This could be used, for example, to emphasize the amino acids that comprise the active site of a protein, in a figure for a publication.

To create a new annotation, simply highlight the residues and molecules you would like to include in the annotation. They can be from any number of different chains or even PDB structures. Then bring up this panel and click on New. You will be prompted for a short name and a longer description, and the edit style button will bring up the standard style editor - except that the style for only the highlighted residues is changed.

You can have any number of style annotations defined. The annotations you have created are listed in the Available area. By default, a new annotation is always turned on. The Displayed area shows which annotations are visible; to turn an individual annotation off, simply select it and click on Turn off, and to redisplay it again, select it and click Turn on.

The bottom row of buttons are operations you can do on whichever annotation is currently selected. Highlight will cause the residues and molecules associated with the annotation to become highlighted. Edit allows you to change the annotation's name, description, and style definition. Move can be used to change the location of the annotation - simply highlight the residues and molecules you would like to move the annotation onto, then press this button. Delete will remove the annotation completely.

If annotations cover overlapping regions of residues, then the style associated with the annotation at the top of the Displayed list is the one that is shown in the overlapping area. If you would like instead for another overlapped style to be displayed, select that annotation and press Move up until that style is at the top of the Displayed list. Similarly, you can lower the annotation's order by pressing Move down.


Structure Window : Window

Structure Window : Window Commands

  • Show sequence viewer
  • Show message log
  • Show log on startup

Show sequence viewer

Use this command to display the sequence/alignment window again if it has been closed.

Show message log

Display the message log. This window contains various diagnostic and informative messages about the program's operation. While this is mostly useful for testing and error reporting, occasionally it will contain useful information during regular use.

Show log on startup

If this is checked, the message log will be opened when the program starts. Otherwise, it will be hidden unless explicitly displayed.


Structure Window : CDD

Structure Window : CDD Commands

The first item in this menu - CDD Overview - is presented when a CDD is downloaded from the server, and presents a description of the CDD and buttons to activate the annotation and reference panels. The rest of this menu is for advanced users and is only available when you have loaded a CDD alignment (of a particular data type) and have turned off the CDD Read-Only option in the Preferences panel.

  • CDD overview

  • Edit name
  • Edit description
  • Edit notes
  • Edit PubMed references
  • Edit book references
  • Edit annotations
  • Reject sequence
  • Show rejects

CDD overview

This is an informative panel that presents information about a CDD when downloaded from the CDD server. It shows the name and description of the domain, and if annotations and literature references are available, the buttons at the bottom will open the Edit Annotations or Edit References panels. If the CDD Read-Only option in the Preferences is checked, then both annotations and references information will be read-only, meaning you can view but not change the information.

Edit name

Edit the short name of the CDD.

Edit description

Edit the CDD description. This text is actually stored as a single long string, so line breaks are not preserved.

Edit notes

Edit the CDD notes. This is free text in multiple lines, so line breaks (where a line is not auto-wrapped) are preserved.

Edit PubMed references

This panel allows you to add PubMed ID links to the literature. Click Add to add a new reference; the available references will appear in the list above. Select any reference and click Launch to start up a web browser to get more information on the article. Click Edit to change the reference number, or Delete to remove it. Move up and Move down can be used to reorder the list.

Edit book references

Similar to the PubMed references panel as described above, this lets you maintain a list of NCBI book references. These are in a format specific to NCBI's book viewer, in the form of name.type#address.sub-address. If you have text in this format in the clipboard, you can use the Paste button to input the entire reference directly, otherwise use New and fill in the four fields. Use Edit to change an existing reference.

Annotate

Annotations on a CDD are linked to columns in the alignment, such as columns of conserved residues at an active site. To create a new annotation, highlight the desired columns in the sequence viewer (or highlight residues of the first sequence), and click on New in the box on the left and enter a description; available annotations will be listed above. Clicking Edit will let you change the description of the selected annotation, and optionally change the column location of that annotation. Highlight will cause the columns of that annotation to be highlighted in the sequence viewer, and Delete removes the annotation completely.

Each annotation can have evidence associated with it - for example, a literature reference that describes in more detail the conservation of the active site. Select an annotation in the list on the left, and then click New to create a new evidence item. There are currently three types of evidence: a text comment, a literature reference (PubMed ID), or "Structure" - which can be any set of residues and molecules (including solvents and heterogens) from a single PDB that illustrate a specific case of the conserved feature annotated for the whole CDD family. Clicking Show will display the selected evidence item, Edit will let you change it, and Delete will remove it. Move up/down lets you change the ordering of the evidence items.

Reject sequence

This brings up a list of all sequences present in both alignment and import windows. You can choose to add any sequence to the CDD's reject list, which will cue the update system to not include the sequence in any subsequent updates, so use with caution! You can also optionally remove the sequence from the alignment and import windows.

Show rejects

Writes a list of rejected sequences to the message log window.


Sequence Window Commands

Please select a command group from the menu bar of the sequence/alignment window:

  • View
  • Edit
  • Mouse mode
  • Unaligned justification
  • Imports


Sequence Window : View

Sequence Window : View Commands

  • Show titles
  • Show geometry violations
  • Find pattern
  • Cache highlights
  • Restore cached highlights
  • Show / hide rows
  • Show PSSM + contact scores
  • Show self-hits
  • Export
  • Show taxonomy
  • Highlight blocks
  • Expand highlights to aligned columns
  • Restrict highlights to row

Show titles

Causes the titles for each sequence to be displayed on the left side of the window. These are on by default, but can be turned off by double-clicking the black separator bar.

Show geometry violations

Shows in green background the places where a loop between aligned blocks is calculated to be too short to span the distance between the the ends of these blocks, based on the coordinates of the first structure of the alignment.

Find pattern

Finds and highlights all non-overlapping occurrences of a residue pattern. This search uses ProSite syntax, described in detail at http://www.expasy.ch/prosite/ - see the description of the PA (pattern) syntax. For example, to search for lysine separated by two to four residues from histidine, enter "k-x(2,4)-h"; unlike ProSite, the letters are case-insensitive, and a trailing period is not required.

Cache highlights

Store the current set of highlights in a transient cache. The highlights will be remembered while the current file is being edited, but will not be saved in an output file and will not persist after Cn3D is exited.

Restore cached highlights

Restore the highlights from the transient cache, removing any existing highlights.

Show / hide rows

Show or hide specific rows of the alignment. All rows selected in the dialog will be displayed. Note that because of the way Cn3D combines pairwise alignments, especially when these alignments are very different (like from a VAST "multiple" alignment of three or more proteins), when you hide rows the alignment of the other rows may change. See the Cn3D Tutorial for more on this topic.

Show PSSM + contact scores

Calculate and display scores for each row based on alignment (PSSM) and contact potential (structure-based) scores. You can specify what balance between PSSM and contact potential to use. These values will then be displayed in the status line at the bottom of the window when you move the mouse over each row.

Show self-hits

Calculates a BLAST alignment for each sequence in the current alignment, using the PSSM constructed from the alignment, and restricting the alignment of each sequence to its currently aligned range. Shows scores for each row, and the percentage of rows that score significantly with the alignment's PSSM.

Export

Used to export the current alignment in one of several formats: FASTA (with gaps), a2m FASTA, text, HTML (with color), or PSSM. The PSSM format is suitable for use with PSI-BLAST or RPS-BLAST.

Show taxonomy

Connects to the NCBI taxonomy server, and constructs the subset of the global taxonomy tree that includes all sequences from the current alignment. In the resulting taxonomy tree window, selecting a node and pressing space or return will cause that node to be completely collapsed or expanded. Double-clicking on a sequence node will highlight that sequence in the sequence window.

Highlight blocks

Highlight all the aligned blocks of the current alignment.

Expand highlights to aligned columns

If there are any highlights in an aligned column, then expand the highlights to all rows of that column.

Restrict highlights to row

Narrow down highlights to a selected row.


Sequence Window : Edit

Sequence Window : Edit Commands

  • Enable editor
  • Undo
  • Redo
  • Split block
  • Merge block
  • Create block
  • Delete block
  • Sync structure colors
  • Always sync structure colors
  • Sort rows
  • Delete row
  • Alignment refiner

Enable editor

Turns on the editor, allowing you to change the alignment.

Undo

Undo the latest operation; Ctrl+Z has the same effect as this menu item. All operations (the items under this Edit menu) that change the alignment are undoable.

Redo

Redo the last operation undone (Shift+Ctrl+Z).

Split block

To split an aligned block, select this item then move the mouse over the block to be split and click once. The block under the mouse will be split such that the new (rightmost) block will start at the column under the mouse.

Merge block

To merge two or more adjacent aligned blocks, select this item then click and drag the mouse across the blocks to be merged. These blocks will then be joined into a single large block.

Create block

To create a new block, select this item then click and drag the mouse across columns of unaligned residues where you would like a new block to be created. Note that all columns of the alignment in the selected area must contain residues (no unaligned gaps).

Delete block

To delete a block, select this item and then click on any aligned block. That block will be removed and the residues marked unaligned.

Sync structure colors

Always sync structure colors

Because the alignments are color-coded, changes to the alignment can cause changes in color of structures in the alignment. By default, Always sync structure colors is on, which means this redrawing of structures will take place automatically. This can be turned off for slower computers where redraws take a long time; use Sync structure colors to manually redraw the structures with any new colors.

Sort rows

Use this item to sort all but the first row of the current alignment. The algorithms available for sorting are:

  • By identifier: sort so that all PDB identifiers are at the top of the list in alphabetical order, followed by all non-PDB's sorted by numerical order for gi's or alphabetical order for accessions.
  • By score: sort by PSSM+contact score. You will be prompted for a weight between these two, then rows will be sorted with the highest scoring rows at the top. The scores will also be displayed in the status line when you move the mouse over each sequence.
  • Float PDBs: simply moves all PDB sequences to the top of the alignment, but without otherwise changing the relative ordering of the PDB sequence or non-structured rows.
  • Float highlights: floats any sequences that contain highlights to the top of the alignment.
  • Float geometry violations: floats any sequences that contain geometry vioaltions.
  • Self-hit: sorts by BLAST score between each sequence and the PSSM constructed from the current alignment.
  • Proximity sort: select this menu item and then click on any but the first row to do a proximity sort. This will move the selected sequence to a position in the alignment according to its relative sequence conservation with the first row. Then the other sequences most similar to the selected row will be clustered around it. This is useful for grouping similar sequences together, and for automatically finding similar sequences in a large alignment.
  • By loop length: select anyplace in an unaligned region, and this will sort the sequences according to the number of residues in that region (highest first).

Delete row

Select this item and then click on any but the first sequence to remove that row from the alignment.

Alignment refiner

The refiner algorithm is documented in a separate page. See also Chakrabarti S. et. al., Nucleic Acids Res. 2006 May 17, 34(9):2598-606 (PMID 16707662).


Sequence Window : Mouse Mode

Sequence Window : Mouse Mode Commands

  • Select rectangle
  • Select columns
  • Select rows
  • Select blocks
  • Horizontal drag
  • Move row

Select rectangle

Use this mode to select residues in an arbitrary rectangle.

Select columns

Use this mode to select whole columns of the alignment.

Select rows

Use this mode to select whole rows of the alignment.

Select blocks

Use this mode to select entire blocks from the alignment.

Horizontal drag

When the editor is on, use this mode to drag residues and block boundaries horizontally in order to change the alignment.

Move row

When the editor is on, use this mode to drag whole rows up and down, to change the order of sequences in the alignment.


Sequence Window : Unaligned Justification

Sequence Window : Unaligned Justification Commands

The horizontal position of unaligned (lower-case) residues is arbitrary, and this menu determines how the unaligned residues are distributed in the spaces between aligned blocks. The options are:

  • Left: unaligned residues are grouped on the left side of the available space.
  • Right: unaligned residues are grouped on the right side of the available space.
  • Center: unaligned residues are grouped together in the center of the available space.
  • Split: unaligned residues are grouped half on the left side and half on the right side of the available space.


Sequence Window : Import

Sequence Window : Import Commands

  • Show imports
  • Realign individual rows
  • Realign rows from list
  • Realign highlighted rows
  • Mark block
  • Clear marks

Show imports

Display the import window for this alignment.

Realign individual rows

Select this item then click on any row(s) of the alignment. These rows will be removed from the multiple alignment and placed in the import window.

Realign rows from list

Select this item to pick sequences from a list. The selected sequences will be removed from the multiple alignment and placed in the import window.

Realign highlighted rows

Select this item to remove from the multiple alignment any sequences with highlights, and place them in the import window.

Mark block

When realigning particular blocks via the import window, it is often convenient to automatically remove an aligned block when a sequence is moved to the import window. Use this item to mark any number of aligned blocks to be removed upon realignment of a sequence.

Clear marks

Removes all marks from aligned blocks.


Cn3D Help: Alignment Refiner

Alignment Refinement

  • Overview
  • Algorithm Summary
  • Parameter Settings
    • General Refiner Parameters
    • Block Shifting Phase Parameters
    • Block Modification Phase Parameters
  • Reference

Overview

This option applies an automatic refinement algorithm to the current multiple alignment in Cn3D's sequence viewer, using the existing 'block model' as a biologically-motivated constraint on the search space. To perform refinement:

  1. enable editing in the sequence viewer (Edit->Enable Editor);
  2. all blocks are refined by default, but to limit refinement to specific blocks, mark them using the 'Import->Mark Block' command -- marked blocks are highlighted in grey;
  3. select the 'Edit->Alignment Refiner' command in the sequence viewer;
  4. unchecking 'Refine all unstructured rows' box in the refinement parameters dialog allows you to limit the refinement to specific non-structure rows, if desired;
  5. change any other dialog settings, then click the 'OK' button.

When the refinement options dialog appears, Cn3D highlights in yellow all initially aligned residues (the yellow highlighting replaces the grey highlight of a marked block, but the mark is remembered). After refinement, any changes made are identified as unhighlighted residues that are now part of an aligned block in the sequence viewer. All originally aligned residues that are no longer aligned in the refined multiple alignment remain in yellow for easy identification of the modification made. The lack of yellow highlights outside the bounds of an aligned block after refinement indicates that no changes were made. If you are dissatisfied with the results, issue the 'Edit->Undo' command in the sequence viewer to restore your original pre-refinement alignment: trial-and-error use of the refiner can thus be performed in a non-destructive manner.

Starting with a passably good initial multiple alignment this alignment refinement procedure corrects a variety of flaws, and provides a means of adding (or removing) alignment columns. The algorithm tends to do best in finding and fixing local misalignments on a single sequence. Further, it performs well even in families that contain evolutionarily distant members, while not disrupting known regions of structural and sequence conservation represented by the block model. (Links to a paper describing the alignment refiner and a stand-alone version of the refiner is given in the Reference section below.)

This feature is not intended for use with an alignment that has not first undergone basic scrutiny.. As a corollary, it has a harder time making global, coordinated changes across a majority of the sequences since the algorithm presumes that 'on average' the input alignment is correct. An alignment contaminated by many sequences unrelated to the domain family being described, that consists of multiple families with sufficiently distinctive features or has other serious errors may be nominally improved for individual sequences but that is not guaranteed. Such initial flaws can confound the algorithm as it assumes all sequences in the alignment do in fact belong to one family, so global misalignments may remain in such a case.

back to top

Algorithm Summary

In concept, the alignment refiner reformulates the 'Block Align' functionality found in the Import Viewer, but instead applies it to sequences in the sequence viewer so as to optimize each block's location (and optionally, size) on each sequence, based on a PSSM computed from the multiple alignment. Provisional alignments in the Import Viewer are not affected by the alignment refiner.

Each independent run of the refiner is composed of one or more cycles. In turn, a cycle can carry out two distinct refinement phases: block shifting and block modification. In the block-shifting phase, blocks on each selected sequence from the multiple alignment are repositioned consistent with the initial block model (i.e., block order, number and size are unmodified). The same dynamic programming algorithm used by the Import Viewer's 'Block Align' is run for each sequence selected for refinement, where the optimization is done against the PSSM computed from the current state of the multiple alignment with the sequence currently under refinement left out. In this phase, sequences are refined in ascending order according to the score of the sequence against the PSSM over the aligned residues at the start of the phase (i.e., from worst to best score vs. the PSSM).

The other (and by default optional) phase in each cycle is 'block modification'. In this phase, pre-existing blocks in the alignment may be extended or contracted at their N- and/or C-terminii. New block creation and block splitting are not allowed. Note that unlike the block-shifting phase, this phase simulataneously alters the block on every sequence in the multiple alignment. Furthermore, this phase does not use a dynamic programming approach but a heuristic which is outlined in the 'Block Modification Parameters' section.

The algorithm has been evaluated and benchmarked against a set of 362 Conserved Domain Database (CDD) alignments and shows an overall score improvement, reliability in retrieval of functional important sites and enhanced sensitivity compared to the original CDD alignment (citation in Reference section). The score used by the alignment refiner is a sum over the sequence-to-PSSM score for each sequence in a multiple alignment. The method is reasonably fast, refining an initial alignment containing a hundred or so columns and several hundreds of highly diverse sequences within minutes.

However, as with all automated methods, the alignment refiner will not 'do the right thing' in every case from a biological point-of-view, even when it improves the alignment score. So, care should be taken to examine the output before proceeding, using 'Undo' and/or re-running the refiner with different settings or for a restricted set of sequences if necessary.

back to top

General Refiner Parameters

  • Number of refinement cycles: (Default: 3)
    Each refinement consists of one or more cycles, the alignment output from a cycle being used as the input to the next. If the alignment score has not changed after a cycle, all remaining cycles are skipped. Cn3D uses the output of the last cycle as the refined alignment.
  • Phase Order: (Default: shift blocks first)
    Active only when both block shifting and block modification phases are being used. In that case, specify the order in which the phases are executed in each cycle.

back to top

Block Shifting Phase Parameters

Note: the reference (master) sequence in the alignment does not undergo refinement.
  • Shift blocks? (Default: checked)
    Uncheck this box to skip the block shifting phase in each cycle.
  • Group rows in sets of: (Default: 1)
    This is an important setting if you have a large alignment or simply want to reduce the refiner's run time. After each sequence processed in this phase, a PSSM recalculation is required before moving to the next sequence. You can speed up the calculation at the expense of accuracy by grouping rows in sets of size greater than one: this recomputes the PSSM after the entire group has undergone block shifting. The number of rows in your alignment affects how large to make this without sacrificing too much accuracy, but as a rule-of-thumb avoid increasing the group size beyond 1/10-th of the number of rows being refined.
  • Refine rows with structure: (Default: unchecked)
    The refiner does not explicitly use structure data. However, rows with structures may have been manually aligned such that they implicitly reflect this added structural information. Prevent the refiner from making change to rows with structure by leaving this box in its default, unchecked state. Check the box to also refine structured rows.
  • Refine all unstructured rows: (Default: checked)
    By default, all unstructured rows are included in the refinement. To select a subset of unstructured rows, first uncheck the box. A second dialog then appears in which you choose the exact group of unstructured rows to refine.
  • Refine using full sequence: (Default: unchecked)
    By default, block shifting on a sequence is constrained to the footprint defined by the first and last aligned residue (plus optional N- and C-terminal extensions mentioned below). Check this box to allow the refiner to shift the blocks across the full sequence length. However, this can be risky especially for multi-domain proteins and proteins with tandem repeats.
  • N-terminal footprint extension: (Default: 20)
    If you are not refining with the full sequence length, this option allows the N-terminal block to shift up to this many residues toward the sequence N-terminus. When using the 'Refine using full sequence' option, negative values restrict blocks from shifting to within this many residues (in absolute value) of the N-terminus.
  • C-terminal footprint extension: (Default: 20)
    If you are not refining with the full sequence length, this option allows the C-terminal block to shift up to this many residues toward the sequence C-terminus. When using the 'Refine using full sequence' option, negative values restrict blocks from shifting to within this many residues (in absolute value) of the C-terminus.
The next three parameters correspond to parameters in the 'Block Align' dialog and control the size of the maximum allowed loop in the refined alignment. (For Cn3D's purposes, a 'loop' is simply a contiguous stretch of unaligned residues.) This is important when full sequences or large footprint extensions are used because the N- and C-terminal blocks can be shifted far from their initial position for reasons unrelated to the quality of the initial alignment. For example, if there are multiple domains in sequence, the block may be shifted out of the current domain of interest into a neighboring domain or tandem repeat. The maximum loop allowed in the refined alignment is: min{ (loop percentile)*(maximum loop length) + loop extension, loop cutoff}.
  • Loop percentile: (Default: 1)
    Fractional size of the maximum loop length desired. For refinement purposes, one typically wants to be able to have loops at least as long as in the input alignment.
  • Loop extension: (Default: 10)
    An additive number of residues a loop can have beyond that implied by the 'Loop percentile' above.
  • Loop cutoff (0=none): (Default: 0)
    An absolute maximum loop length, measured in number of residues. Useful if one or more sequence in the alignment has an anomalously large unaligned insertion.

back to top

Block Modification Phase Parameters

  • Change block model? (Default: No)
    The default is to not execute the block modification phase in each cycle. When it is executed, you have three options: allow existing block to be extended ('Only expand'), allow existing blocks to be shortened ('Only shrink') and allow blocks to be extended and shortened ('Expand and shrink').
  • Expand first? (Default: Expand first)
    When 'Expand and shrink' is chosen for 'Change block model?', select whether attempts to expand or attempts to shrink are performed first.
  • Minimum block size: (Default: 1)
    Specify the smallest refined block size: blocks will not be shrunk to less than this size. This value must be positive: the refiner does not permit block deletion. Blocks in the initial alignment that start out smaller than this size are exempt from this criteria when expanding (i.e., the refiner will not force a block to expand to reach the minimum block size).

The following three threshold parameters control the decision as to whether it is advantageous to extend or shrink a column. A column can be added to the N- or C-terminal end of a block if: i) no sequence in the alignment has a gap in the column, and ii) each of the three quantities computed for the column exceed the threshold values. Expansion at a block terminus stops as soon as a column failing this test is encountered. Similarly, a column can be removed from the N- or C-terminal end of a block if all of the three quantities computed for that column fall below their respective threshold values. Shrinking of a block terminus stops as soon as a column fail this test is encountered, or the minimum block size is reached.

  • Median PSSM score threshold: (Default: 3)
    The PSSM score of each aligned residue in the column is found, and the median of all such values determined. This threshold specifies the minimum median PSSM score for a column to be considered good enough to be added to/kept in an alignment.
  • Voting percentage (% of rows vote to extend): (Default: 70%)
    The fraction of residues with non-negative PSSM scores in the column. This parameter tries to avoid columns with many negatively scored residues from being added to an alignment.
  • Weighted (by PSSM score) voting percentage: (Default: 70%)
    Similar to the previous parameter, except that each residue in a column "votes" in proportion to the magnitude of its score, not just its sign. This parameter tries to compensate for cases of noisy columns that might have a few marginally negatively scored residues but is otherwise well conserved.

back to top

Reference

The Cn3D alignment refiner was initially developed as a stand-alone program for block-based multiple alignment refinement. Further details can be found in the paper:

"Refining multiple sequence alignments with conserved core regions", Saikat Chakrabarti, Christopher J. Lanczycki, Anna R. Panchenko, Teresa M. Przytycka, Paul A. Thiessen and Stephen H. Bryant (2006) Nucl. Acids Res., 34, 2598-2606 (PMID: 16707662).

The stand-alone program, which takes Cn3D-readable files as input, may be downloaded from the NCBI ftp site.


Import Window Commands

Please select a command group from the menu bar of the import window:

  • View
  • Edit
  • Mouse mode
  • Unaligned justification
  • Algorithms
  • Alignments


Import Window : View

Import Window : View Commands

The items in this menu have the same meaning as they do in the Sequence Window : View menu.


Import Window : Edit

Import Window : Edit Commands

The items in this menu mostly have the same meaning as they do in the Sequence Window : Edit menu, with a few additions:

  • Delete all blocks
  • Delete all blocks in all alignments
  • Sort imports
  • Import sequences
  • Import structure

Delete all blocks

Delete all the blocks in the selected alignment.

Delete all blocks in all alignments

Delete all the blocks in all the alignments in the import window.

Sort imports

Sorts imports by:

  • Sequence identifier: (of the imported sequence), putting PDB sequences at the top in alphabetical order, followed by non-structured sequences in numerical order of their identifier.
  • PSSM score: sorts rows by the sum of the residue-to-PSSM scores for all aligned residues, with the highest at the top.

Import sequences

Use this item to import new sequences. You will be given a choice to import multiple sequences from a FASTA file, or a single sequence from NCBI via the network. The new sequences will be imported without an alignment. It will then be up to you to align the sequences manually or with one of the available algorithms.

Import structure

Allows you to import a new structure and the sequence of the aligned chain. You will be given a choice whether to import from a file or directly from NCBI via the network; if you import from a file, the structure must be of the type downloaded from the MMDB server, and must be of the right all-atom or alpha-only type to match the existing structures. After the structure is loaded, Cn3D will query the VAST database to see whether a structure alignment exists; if so, it will load both the structure alignment and the corresponding sequence alignment. If VAST has no alignment for the two chains, the sequence will be imported without any alignment, and you'll have to align it manually or using one of the built-in alignment algorithms.

Note that the structure will not appear right away. You must first save the data to a file, and then re-load. And if there is an existing multiple alignment already, depending on the data type the structure may not be visible until after you merge the new sequence into the multiple alignment.


Import Window : Mouse Mode

Import Window : Mouse Mode Commands

The items in this menu have the same meaning as they do in the Sequence Window : Mouse Mode menu.


Import Window : Unaligned Justification

Import Window : Unaligned Justification Commands

The items in this menu have the same meaning as they do in the Sequence Window : Unaligned Justification menu.


Import Window : Algorithms

Import Window : Algorithms Commands

  • Block align single
  • Block align N
  • BLAST single
  • BLAST/PSSM single
  • BLAST neighbor
  • Thread single
  • Thread all
  • Extend single
  • Extend all
  • Set region
  • Reset all regions

Block align single

The block alignment algorithm is a new alignment method being developed at NCBI. Briefly, it uses a dynamic programming algorithm, except the alignment is created by searching with whole (gapless) blocks - corresponding to the blocks of the alignment in Cn3D - rather than one residue at a time as in traditional sequence alignments. See Kann M.G. et. al., Bioinformatics, 2005 Apr 15, 21(8):1451-6 (PMID 15613392).

The block alignment options panel contains numeric fields that correspond to the parameters of the block alignment algorithm. The options at the bottom are: Global alignment to switch between global and local alignment modes, Merge to either never merge, merge in each succesfully aligned row into the multiple alignment and recalculate the PSSM before proceeding with the next alignment, or merge after all alignments are completed, and Keep existing blocks to control whether to freeze the alignment of existing blocks (as opposed to always realigning all blocks).

Block align N

Like Block align single, except it attempts to run the block alignment algorithm on the first N import alignments; you will be prompted for how many (N) sequences to realign.

BLAST single

Uses NCBI's BLAST-two-sequences algorithm with default parameters to align an import sequence to the current first sequence of the multiple alignment, discarding any existing alignment. This is not intended as a complete interface to the BLAST algorithm, but only to provide a starting point for aligning a new sequence. See NCBI's BLAST web pages for more complete BLAST functionality. The aligned region on the principal sequence will be limited to the aligned region in the multiple alignment window, if there is a multiple alignment present. The aligned region on the imported sequence will be unlimited, unless this sequence has been demoted from the multiple alignment, in which case the original aligned region is used as a guide. The sequence's aligned region can also be set manually using the Set region command.

BLAST/PSSM single

Similar to BLAST single, except that a sequence to profile BLAST alignment is performed, using a profile constructed from the current multiple alignment. Aligned region restrictions are the same as described above.

BLAST neighbor

Computes BLAST-two-sequences for the import and all rows of the multiple alignment. The highest scoring such pairwise alignment is then used to infer an alignment of the import with the principal sequence of the multiple alignment, and the import is merged accordingly.

Thread single

This command is used to align a single sequence to the first structure of the multiple alignment, using NCBI's threading algorithm. When you select this item and then click on a sequence pair, a threading options panel comes up. A complete discussion of this algorithm and the details of these settings is beyond the scope of this document, and in many cases the default numerical values will be adequate. If Merge results is checked, then if the results of threading yield an alignment compatible with the current multiple alignment, then the new alignment will be merged in. If Freeze blocks is checked, then block boundaries that are not adjacent to realigned blocks are not allowed to move, which saves time in the threader.

Thread all

This has the same effect as thread single, except it will run the threader on all sequences in the import window, merging each one after it is threaded if Merge results is on.

Extend single

This algorithm simply grows blocks of the selected sequence to either side, regardless of residue identity or any scoring, attempting only to make blocks (just) large enough so that the import alignment can be merged into the multiple alignment. It will stop if there is any ambiguity - for example where blocks on either side of a short insert would "compete" for residues.

Extend all

Same as extend single, except extension is performed on all import sequences.

Set region

Used to set the region of an imported sequence that is allowed to be aligned. This is useful, for example, if the imported sequence contains repeated regions and you'd like to construct an alignment across a specific repeat.

Reset all regions

Reset all regions on all sequences, so that alignments are unrestricted.


Import Window : Alignments

Import Window : Alignments Commands

  • Merge single
  • Merge to neighbor
  • Merge all
  • Delete single
  • Delete all

Merge single

Select this item and then click on an import sequence to merge it into the end of the multiple alignment. Note that the merge will succeed if and only if all blocks of the multiple alignment are contained in blocks of the import alignment, without insertions. An unmergeable import will be marked with a red background to indicate where the alignment is incompatible.

Merge to neighbor

Similar to merge single except that the sequence is positioned in the multiple alignment right after its closest neighbor (by simple sum of BLOSUM62 scores).

Merge all

Similar to merge single, except all imports that are compatible with the multiple alignment are merged in.

Delete single

Select this item and then click on an import to delete it.

Delete all

Removes all import alignments from the window.


Key and Mouse Actions

  • Keyboard Shortcuts
  • Mouse Actions

Keyboard Shortcuts

There are keyboard shortcuts for a few specific Structure Window and Sequence Window commands in Cn3D. These shortcuts may not available on all platforms, but the equivalent menu items are always present. "Ctrl/Meta" means that on some platforms, the 'control' key is used (PC and UNIX), and on others the 'meta' key is used (Macintosh).

Keyboard shorcuts in the Structure Window
Open | Ctrl/Meta + O
Network load | Ctrl/Meta + N
Save | Ctrl/Meta + S
Zoom in | Z
Zoom out | X
Show next frame | Right Arrow
Show previous frame | Left Arrow
Show first frame | Down Arrow
Show last frame | Up Arrow
Show all frames | A
Animate: play frames | P
Animate: spin | N
Stop animation | S
Show everything | E
Show aligned domains | D
Select molecule | M

Keyboard shorcuts in the Sequence Windows
Undo | Ctrl + Z
Redo | Shift + Ctrl + Z
Select rectangle | S
Select columns | C
Select blocks | B
Select rows | R
Horizontal drag | H

Mouse Actions

The following tables tell how to interact with Cn3D using the mouse and keyboard together. There are two tables: one for the Structure Window, and one for the Sequence Window. "Left-drag" here means hold down the left button (or the only button, on a Macintosh) and drag the mouse. "Shift + drag" means hold down the 'shift' key while dragging the mouse.

Mouse actions in the Structure Window
Rotate | Left-drag
Translate | Shift + left-drag
Zoom | Ctrl + left-drag
Select residue | Double-click
Set rotation center | Ctrl/Meta + double-click

Mouse actions in Sequence and Import Windows
Set selection | Left-drag
Extend selection | Shift + left-drag
Invert selection | Ctrl/Meta + left-drag
Browse Entrez | Left-click on title/identifier


Contents

Commands in Cn3D (version 4.2)

This help book describes the commands available in Cn3D v4.2. There are four sections, one for each of the three main windows in Cn3D - each of which has its own menu bar, plus one section on keyboard and mouse actions.

Please select one of these topics:

  • Structure Window Menus
  • Sequence Window Menus
  • Import Window Menus
  • Key and Mouse Actions